GETPIVOTDATA

The GETPIVOTDATA function queries a pivot table and returns specific data based on the pivot table structure, instead of cell references. The main advantage of using this function is that it ensures that the correct data is returned, even if the pivot table layout is changed.

Syntax Argument Description data_field (Required) The name of the PivotTable field that contains the data that you want to retrieve. This needs to be in quotes. pivot_table (Required) A reference to any cell, range of cells, or named range of cells in a PivotTable. This information is used to determine which PivotTable contains the data that you want to retrieve. field1, item1, field2, item2… (Optional) 1 to 126 pairs of field names and item names that describe the data that you want to retrieve. The pairs can be in any order. Field names and names for items other than dates and numbers need to be enclosed in quotation marks. Usage notes The GETPIVOTDATA function returns visible data from a PivotTable. To extract data from a cell in a pivot table, you can enter a normal cell link, such as =B5, or you can use the GetPivotData formula, which is specially designed to extract data from a pivot table. This formula will be created automatically when you reference a cell in a PivotTable. You can also select whether to display the GETPIVOTDATA formula or display normal cell reference through the workbook pivotAreaReference option Benefits The advantage of using the GETPIVOTDATA function is that it uses criteria to ensure that the correct data is returned, even if the pivot table layout is changed. Extension The GETPIVOTDATA function supports spill, so you can get a range of pivot data based on field and item references that you defined.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 }); initSpread(spread); var pivotLayoutSheet = spread.getSheet(0); initPivotTable(pivotLayoutSheet); initStyles(spread); setGetPivotDataFunction(pivotLayoutSheet); }; function initSpread(spread) { spread.suspendPaint(); spread.options.allowDynamicArray = true; var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); } function initPivotTable(sheet) { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc }); let style = new GC.Spread.Sheets.Style(); style.formatter = "$ #,##0"; myPivotTable.setStyle({dataOnly: true}, style); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); } function setGetPivotDataFunction(sheet) { sheet.setColumnWidth(8, 20); sheet.setValue(1, 9, 'GETPIVOTDATA basic usage'); sheet.setStyle(1, 9, 'intro'); var formula1 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Tess","Cars","Audi","Qt","Qtr2")'; sheet.setValue(3, 9, 'Returns the total Audi sales made by Tess in the second quarter'); sheet.setStyle(3, 9, 'introSec'); sheet.setValue(4, 9, formula1); sheet.setStyle(4, 9, 'formula'); sheet.getCell(5,9).formatter("$ #,##0"); sheet.setFormula(5, 9, formula1); sheet.setStyle(5, 9, 'result'); var formula2 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Alan","Cars","BMW")'; sheet.setValue(7, 9, 'Returns the total BMW sales made by Alan'); sheet.setStyle(7, 9, 'introSec'); sheet.setValue(8, 9, formula2); sheet.setStyle(8, 9, 'formula'); sheet.getCell(9,9).formatter("$ #,##0"); sheet.setFormula(9, 9, formula2); sheet.setStyle(9, 9, 'result'); // Invoked formula var formula3 = '=GETPIVOTDATA("Totals",$B$2,"Qt","Qtr1")'; sheet.setValue(11, 9, 'Returns the total sales for the first quarter'); sheet.setStyle(11, 9, 'introSec'); sheet.setValue(12, 9, formula3); sheet.setStyle(12, 9, 'formula'); sheet.getCell(13,9).formatter("$ #,##0"); sheet.setFormula(13, 9, formula3); sheet.setStyle(13, 9, 'result'); var formula4 = '=GETPIVOTDATA("Totals",$B$2)'; sheet.setValue(15, 9, 'Returns the grand total'); sheet.setStyle(15, 9, 'introSec'); sheet.setValue(16, 9, formula4); sheet.setStyle(16, 9, 'formula'); sheet.getCell(17,9).formatter("$ #,##0"); sheet.setFormula(17, 9, formula4); sheet.setStyle(17, 9, 'result'); var formula5 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson",{"Alan";"John";"Tess"},"Cars",C10:C12,"Qt",E3:G3)'; sheet.setValue(19, 9, 'Returns the spill range of total Audi/BMW/Mercedes sales made by Alan/John/Tess in the Qtr2/Qtr3/Qtr4 quarter'); sheet.setStyle(19, 9, 'introSec'); sheet.setValue(20, 9, formula5); sheet.setStyle(20, 9, 'formula'); sheet.setFormula(21, 9, formula5); sheet.getRange(21, 9, 3, 3).hAlign(0); } function initStyles(spread) { var introStyle = new GC.Spread.Sheets.Style(); introStyle.name = 'intro'; introStyle.font = 'normal bold 13px Segoe UI'; introStyle.foreColor = "#172b4d"; spread.addNamedStyle(introStyle); var introSecStyle = new GC.Spread.Sheets.Style(); introSecStyle.name = 'introSec'; introSecStyle.font = 'normal bold 12px Segoe UI'; introSecStyle.foreColor = "#000"; spread.addNamedStyle(introSecStyle); var formulaStyle = new GC.Spread.Sheets.Style(); formulaStyle.name = 'formula'; formulaStyle.font = 'normal bold 12px Consolas'; formulaStyle.foreColor = "#c00000"; spread.addNamedStyle(formulaStyle); var resultStyle = new GC.Spread.Sheets.Style(); resultStyle.name = 'result'; resultStyle.hAlign = 0; spread.addNamedStyle(resultStyle); } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 210px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }

Syntax
Argument
Description
data_field
(Required) The name of the PivotTable field that contains the data that you want to retrieve. This needs to be in quotes.
pivot_table
(Required) A reference to any cell, range of cells, or named range of cells in a PivotTable. This information is used to determine which PivotTable contains the data that you want to retrieve.
field1, item1, field2, item2…
(Optional) 1 to 126 pairs of field names and item names that describe the data that you want to retrieve. The pairs can be in any order. Field names and names for items other than dates and numbers need to be enclosed in quotation marks.
Usage notes
The GETPIVOTDATA function returns visible data from a PivotTable.
To extract data from a cell in a pivot table, you can enter a normal cell link, such as =B5, or you can use the GetPivotData formula, which is specially designed to extract data from a pivot table. This formula will be created automatically when you reference a cell in a PivotTable.
You can also select whether to display the GETPIVOTDATA formula or display normal cell reference through the workbook pivotAreaReference option
Benefits
The advantage of using the GETPIVOTDATA function is that it uses criteria to ensure that the correct data is returned, even if the pivot table layout is changed.
Extension
The GETPIVOTDATA function supports spill, so you can get a range of pivot data based on field and item references that you defined.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
pt: any;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
this.initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
let pt = this.initPivotTable(pivotLayoutSheet);
this.initStyles(spread);
this.setGetPivotDataFunction(pivotLayoutSheet);
this.pt = pt;
}
initSheets(spread: GC.Spread.Sheets.Workbook) {
spread.suspendPaint();
spread.options.allowDynamicArray = true;
var sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
var sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
initPivotTable(sheet: GC.Spread.Sheets.Worksheet) {
var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan","John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc });
let carList = ["Audi","BMW","Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc });
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
myPivotTable.setStyle({dataOnly: true}, style);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
setGetPivotDataFunction(sheet: GC.Spread.Sheets.Worksheet) {
sheet.setColumnWidth(8, 20);
sheet.setValue(1, 9, 'GETPIVOTDATA basic usage');
sheet.setStyle(1, 9, 'intro');
var formula1 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Tess","Cars","Audi","Qt","Qtr2")';
sheet.setValue(3, 9, 'Returns the total Audi sales made by Tess in the second quarter');
sheet.setStyle(3, 9, 'introSec');
sheet.setValue(4, 9, formula1);
sheet.setStyle(4, 9, 'formula');
sheet.getCell(5,9).formatter("$ #,##0");
sheet.setFormula(5, 9, formula1);
sheet.setStyle(5, 9, 'result');
var formula2 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Alan","Cars","BMW")';
sheet.setValue(7, 9, 'Returns the total BMW sales made by Alan');
sheet.setStyle(7, 9, 'introSec');
sheet.setValue(8, 9, formula2);
sheet.setStyle(8, 9, 'formula');
sheet.getCell(9,9).formatter("$ #,##0");
sheet.setFormula(9, 9, formula2);
sheet.setStyle(9, 9, 'result');
// Invoked formula
var formula3 = '=GETPIVOTDATA("Totals",$B$2,"Qt","Qtr1")';
sheet.setValue(11, 9, 'Returns the total sales for the first quarter');
sheet.setStyle(11, 9, 'introSec');
sheet.setValue(12, 9, formula3);
sheet.setStyle(12, 9, 'formula');
sheet.getCell(13,9).formatter("$ #,##0");
sheet.setFormula(13, 9, formula3);
sheet.setStyle(13, 9, 'result');
var formula4 = '=GETPIVOTDATA("Totals",$B$2)';
sheet.setValue(15, 9, 'Returns the grand total');
sheet.setStyle(15, 9, 'introSec');
sheet.setValue(16, 9, formula4);
sheet.setStyle(16, 9, 'formula');
sheet.getCell(17,9).formatter("$ #,##0");
sheet.setFormula(17, 9, formula4);
sheet.setStyle(17, 9, 'result');
var formula5 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson",{"Alan";"John";"Tess"},"Cars",C10:C12,"Qt",E3:G3)';
sheet.setValue(19, 9, 'Returns the spill range of total Audi/BMW/Mercedes sales made by Alan/John/Tess in the Qtr2/Qtr3/Qtr4 quarter');
sheet.setStyle(19, 9, 'introSec');
sheet.setValue(20, 9, formula5);
sheet.setStyle(20, 9, 'formula');
sheet.setFormula(21, 9, formula5);
sheet.getRange(21, 9, 3, 3).hAlign(0);
}
initStyles(spread: GC.Spread.Sheets.Workbook) {
var introStyle = new GC.Spread.Sheets.Style();
introStyle.name = 'intro';
introStyle.font = 'normal bold 13px Segoe UI';
introStyle.foreColor = "#172b4d";
spread.addNamedStyle(introStyle);
var introSecStyle = new GC.Spread.Sheets.Style();
introSecStyle.name = 'introSec';
introSecStyle.font = 'normal bold 12px Segoe UI';
introSecStyle.foreColor = "#000";
spread.addNamedStyle(introSecStyle);
var formulaStyle = new GC.Spread.Sheets.Style();
formulaStyle.name = 'formula';
formulaStyle.font = 'normal bold 12px Consolas';
formulaStyle.foreColor = "#c00000";
spread.addNamedStyle(formulaStyle);
var resultStyle = new GC.Spread.Sheets.Style();
resultStyle.name = 'result';
resultStyle.hAlign = 0;
spread.addNamedStyle(resultStyle);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 210px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Syntax
Argument
Description
data_field
(Required) The name of the PivotTable field that contains the data that you want to retrieve. This needs to be in quotes.
pivot_table
(Required) A reference to any cell, range of cells, or named range of cells in a PivotTable. This information is used to determine which PivotTable contains the data that you want to retrieve.
field1, item1, field2, item2…
(Optional) 1 to 126 pairs of field names and item names that describe the data that you want to retrieve. The pairs can be in any order. Field names and names for items other than dates and numbers need to be enclosed in quotation marks.
Usage notes
The GETPIVOTDATA function returns visible data from a PivotTable.
To extract data from a cell in a pivot table, you can enter a normal cell link, such as =B5, or you can use the GetPivotData formula, which is specially designed to extract data from a pivot table. This formula will be created automatically when you reference a cell in a PivotTable.
You can also select whether to display the GETPIVOTDATA formula or display normal cell reference through the workbook pivotAreaReference option
Benefits
The advantage of using the GETPIVOTDATA function is that it uses criteria to ensure that the correct data is returned, even if the pivot table layout is changed.
Extension
The GETPIVOTDATA function supports spill, so you can get a range of pivot data based on field and item references that you defined.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.options.allowDynamicArray = true;
initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
initPivotTable(pivotLayoutSheet);
initStyles(spread);
setGetPivotDataFunction(pivotLayoutSheet);
}
const initSheets = (spread) => {
spread.suspendPaint();
var sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
var sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
const initPivotTable = (sheet) => {
var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan", "John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc });
let carList = ["Audi", "BMW", "Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc });
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
myPivotTable.setStyle({ dataOnly: true }, style);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
const setGetPivotDataFunction = (sheet) => {
sheet.setColumnWidth(8, 20);
sheet.setValue(1, 9, 'GETPIVOTDATA basic usage');
sheet.setStyle(1, 9, 'intro');
var formula1 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Tess","Cars","Audi","Qt","Qtr2")';
sheet.setValue(3, 9, 'Returns the total Audi sales made by Tess in the second quarter');
sheet.setStyle(3, 9, 'introSec');
sheet.setValue(4, 9, formula1);
sheet.setStyle(4, 9, 'formula');
sheet.getCell(5, 9).formatter("$ #,##0");
sheet.setFormula(5, 9, formula1);
sheet.setStyle(5, 9, 'result');
var formula2 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Alan","Cars","BMW")';
sheet.setValue(7, 9, 'Returns the total BMW sales made by Alan');
sheet.setStyle(7, 9, 'introSec');
sheet.setValue(8, 9, formula2);
sheet.setStyle(8, 9, 'formula');
sheet.getCell(9, 9).formatter("$ #,##0");
sheet.setFormula(9, 9, formula2);
sheet.setStyle(9, 9, 'result');
// Invoked formula
var formula3 = '=GETPIVOTDATA("Totals",$B$2,"Qt","Qtr1")';
sheet.setValue(11, 9, 'Returns the total sales for the first quarter');
sheet.setStyle(11, 9, 'introSec');
sheet.setValue(12, 9, formula3);
sheet.setStyle(12, 9, 'formula');
sheet.getCell(13, 9).formatter("$ #,##0");
sheet.setFormula(13, 9, formula3);
sheet.setStyle(13, 9, 'result');
var formula4 = '=GETPIVOTDATA("Totals",$B$2)';
sheet.setValue(15, 9, 'Returns the grand total');
sheet.setStyle(15, 9, 'introSec');
sheet.setValue(16, 9, formula4);
sheet.setStyle(16, 9, 'formula');
sheet.getCell(17, 9).formatter("$ #,##0");
sheet.setFormula(17, 9, formula4);
sheet.setStyle(17, 9, 'result');
var formula5 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson",{"Alan";"John";"Tess"},"Cars",C10:C12,"Qt",E3:G3)';
sheet.setValue(19, 9, 'Returns the spill range of total Audi/BMW/Mercedes sales made by Alan/John/Tess in the Qtr2/Qtr3/Qtr4 quarter');
sheet.setStyle(19, 9, 'introSec');
sheet.setValue(20, 9, formula5);
sheet.setStyle(20, 9, 'formula');
sheet.setFormula(21, 9, formula5);
sheet.getRange(21, 9, 3, 3).hAlign(0);
}
const initStyles = (spread) => {
var introStyle = new GC.Spread.Sheets.Style();
introStyle.name = 'intro';
introStyle.font = 'normal bold 13px Segoe UI';
introStyle.foreColor = "#172b4d";
spread.addNamedStyle(introStyle);
var introSecStyle = new GC.Spread.Sheets.Style();
introSecStyle.name = 'introSec';
introSecStyle.font = 'normal bold 12px Segoe UI';
introSecStyle.foreColor = "#000";
spread.addNamedStyle(introSecStyle);
var formulaStyle = new GC.Spread.Sheets.Style();
formulaStyle.name = 'formula';
formulaStyle.font = 'normal bold 12px Consolas';
formulaStyle.foreColor = "#c00000";
spread.addNamedStyle(formulaStyle);
var resultStyle = new GC.Spread.Sheets.Style();
resultStyle.name = 'result';
resultStyle.hAlign = 0;
spread.addNamedStyle(resultStyle);
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.pt = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.options.allowDynamicArray = true;
this.initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
let pt = this.initPivotTable(pivotLayoutSheet);
this.initStyles(spread);
this.setGetPivotDataFunction(pivotLayoutSheet);
this.pt = pt;
}
initSheets(spread) {
spread.suspendPaint();
var sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
var sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
initPivotTable(sheet) {
var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan","John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc });
let carList = ["Audi","BMW","Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc });
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
myPivotTable.setStyle({dataOnly: true}, style);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
setGetPivotDataFunction(sheet) {
sheet.setColumnWidth(8, 20);
sheet.setValue(1, 9, 'GETPIVOTDATA basic usage');
sheet.setStyle(1, 9, 'intro');
var formula1 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Tess","Cars","Audi","Qt","Qtr2")';
sheet.setValue(3, 9, 'Returns the total Audi sales made by Tess in the second quarter');
sheet.setStyle(3, 9, 'introSec');
sheet.setValue(4, 9, formula1);
sheet.setStyle(4, 9, 'formula');
sheet.getCell(5,9).formatter("$ #,##0");
sheet.setFormula(5, 9, formula1);
sheet.setStyle(5, 9, 'result');
var formula2 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Alan","Cars","BMW")';
sheet.setValue(7, 9, 'Returns the total BMW sales made by Alan');
sheet.setStyle(7, 9, 'introSec');
sheet.setValue(8, 9, formula2);
sheet.setStyle(8, 9, 'formula');
sheet.getCell(9,9).formatter("$ #,##0");
sheet.setFormula(9, 9, formula2);
sheet.setStyle(9, 9, 'result');
// Invoked formula
var formula3 = '=GETPIVOTDATA("Totals",$B$2,"Qt","Qtr1")';
sheet.setValue(11, 9, 'Returns the total sales for the first quarter');
sheet.setStyle(11, 9, 'introSec');
sheet.setValue(12, 9, formula3);
sheet.setStyle(12, 9, 'formula');
sheet.getCell(13,9).formatter("$ #,##0");
sheet.setFormula(13, 9, formula3);
sheet.setStyle(13, 9, 'result');
var formula4 = '=GETPIVOTDATA("Totals",$B$2)';
sheet.setValue(15, 9, 'Returns the grand total');
sheet.setStyle(15, 9, 'introSec');
sheet.setValue(16, 9, formula4);
sheet.setStyle(16, 9, 'formula');
sheet.getCell(17,9).formatter("$ #,##0");
sheet.setFormula(17, 9, formula4);
sheet.setStyle(17, 9, 'result');
var formula5 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson",{"Alan";"John";"Tess"},"Cars",C10:C12,"Qt",E3:G3)';
sheet.setValue(19, 9, 'Returns the spill range of total Audi/BMW/Mercedes sales made by Alan/John/Tess in the Qtr2/Qtr3/Qtr4 quarter');
sheet.setStyle(19, 9, 'introSec');
sheet.setValue(20, 9, formula5);
sheet.setStyle(20, 9, 'formula');
sheet.setFormula(21, 9, formula5);
sheet.getRange(21, 9, 3, 3).hAlign(0);
}
initStyles(spread) {
var introStyle = new GC.Spread.Sheets.Style();
introStyle.name = 'intro';
introStyle.font = 'normal bold 13px Segoe UI';
introStyle.foreColor = "#172b4d";
spread.addNamedStyle(introStyle);
var introSecStyle = new GC.Spread.Sheets.Style();
introSecStyle.name = 'introSec';
introSecStyle.font = 'normal bold 12px Segoe UI';
introSecStyle.foreColor = "#000";
spread.addNamedStyle(introSecStyle);
var formulaStyle = new GC.Spread.Sheets.Style();
formulaStyle.name = 'formula';
formulaStyle.font = 'normal bold 12px Consolas';
formulaStyle.foreColor = "#c00000";
spread.addNamedStyle(formulaStyle);
var resultStyle = new GC.Spread.Sheets.Style();
resultStyle.name = 'result';
resultStyle.hAlign = 0;
spread.addNamedStyle(resultStyle);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 210px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Syntax
Argument
Description
data_field
(Required) The name of the PivotTable field that contains the data that you want to retrieve. This needs to be in quotes.
pivot_table
(Required) A reference to any cell, range of cells, or named range of cells in a PivotTable. This information is used to determine which PivotTable contains the data that you want to retrieve.
field1, item1, field2, item2…
(Optional) 1 to 126 pairs of field names and item names that describe the data that you want to retrieve. The pairs can be in any order. Field names and names for items other than dates and numbers need to be enclosed in quotation marks.
Usage notes
The GETPIVOTDATA function returns visible data from a PivotTable.
To extract data from a cell in a pivot table, you can enter a normal cell link, such as =B5, or you can use the GetPivotData formula, which is specially designed to extract data from a pivot table. This formula will be created automatically when you reference a cell in a PivotTable.
You can also select whether to display the GETPIVOTDATA formula or display normal cell reference through the workbook pivotAreaReference option
Benefits
The advantage of using the GETPIVOTDATA function is that it uses criteria to ensure that the correct data is returned, even if the pivot table layout is changed.
Extension
The GETPIVOTDATA function supports spill, so you can get a range of pivot data based on field and item references that you defined.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import "@mescius/spread-sheets-pivot-addon";
function initSpread (spread) {
initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
initPivotTable(pivotLayoutSheet);
initStyles(spread);
setGetPivotDataFunction(pivotLayoutSheet);
}
function initSheets (spread) {
spread.suspendPaint();
spread.options.allowDynamicArray = true;
var sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
var sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
function initPivotTable (sheet) {
var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan","John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc });
let carList = ["Audi","BMW","Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc });
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
myPivotTable.setStyle({dataOnly: true}, style);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
function setGetPivotDataFunction (sheet) {
sheet.setColumnWidth(8, 20);
sheet.setValue(1, 9, 'GETPIVOTDATA basic usage');
sheet.setStyle(1, 9, 'intro');
var formula1 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Tess","Cars","Audi","Qt","Qtr2")';
sheet.setValue(3, 9, 'Returns the total Audi sales made by Tess in the second quarter');
sheet.setStyle(3, 9, 'introSec');
sheet.setValue(4, 9, formula1);
sheet.setStyle(4, 9, 'formula');
sheet.getCell(5,9).formatter("$ #,##0");
sheet.setFormula(5, 9, formula1);
sheet.setStyle(5, 9, 'result');
var formula2 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson","Alan","Cars","BMW")';
sheet.setValue(7, 9, 'Returns the total BMW sales made by Alan');
sheet.setStyle(7, 9, 'introSec');
sheet.setValue(8, 9, formula2);
sheet.setStyle(8, 9, 'formula');
sheet.getCell(9,9).formatter("$ #,##0");
sheet.setFormula(9, 9, formula2);
sheet.setStyle(9, 9, 'result');
// Invoked formula
var formula3 = '=GETPIVOTDATA("Totals",$B$2,"Qt","Qtr1")';
sheet.setValue(11, 9, 'Returns the total sales for the first quarter');
sheet.setStyle(11, 9, 'introSec');
sheet.setValue(12, 9, formula3);
sheet.setStyle(12, 9, 'formula');
sheet.getCell(13,9).formatter("$ #,##0");
sheet.setFormula(13, 9, formula3);
sheet.setStyle(13, 9, 'result');
var formula4 = '=GETPIVOTDATA("Totals",$B$2)';
sheet.setValue(15, 9, 'Returns the grand total');
sheet.setStyle(15, 9, 'introSec');
sheet.setValue(16, 9, formula4);
sheet.setStyle(16, 9, 'formula');
sheet.getCell(17,9).formatter("$ #,##0");
sheet.setFormula(17, 9, formula4);
sheet.setStyle(17, 9, 'result');
var formula5 = '=GETPIVOTDATA("Totals",$B$2,"Salesperson",{"Alan";"John";"Tess"},"Cars",C10:C12,"Qt",E3:G3)';
sheet.setValue(19, 9, 'Returns the spill range of total Audi/BMW/Mercedes sales made by Alan/John/Tess in the Qtr2/Qtr3/Qtr4 quarter');
sheet.setStyle(19, 9, 'introSec');
sheet.setValue(20, 9, formula5);
sheet.setStyle(20, 9, 'formula');
sheet.setFormula(21, 9, formula5);
sheet.getRange(21, 9, 3, 3).hAlign(0);
}
function initStyles (spread) {
var introStyle = new GC.Spread.Sheets.Style();
introStyle.name = 'intro';
introStyle.font = 'normal bold 13px Segoe UI';
introStyle.foreColor = "#172b4d";
spread.addNamedStyle(introStyle);
var introSecStyle = new GC.Spread.Sheets.Style();
introSecStyle.name = 'introSec';
introSecStyle.font = 'normal bold 12px Segoe UI';
introSecStyle.foreColor = "#000";
spread.addNamedStyle(introSecStyle);
var formulaStyle = new GC.Spread.Sheets.Style();
formulaStyle.name = 'formula';
formulaStyle.font = 'normal bold 12px Consolas';
formulaStyle.foreColor = "#c00000";
spread.addNamedStyle(formulaStyle);
var resultStyle = new GC.Spread.Sheets.Style();
resultStyle.name = 'result';
resultStyle.hAlign = 0;
spread.addNamedStyle(resultStyle);
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 210px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);